<script>
    export default {
        name: 'ErrorBoundary',
        data() {
            return {
                error: false,
                errorMessage: '',
                info: '',
            };
        },
        errorCaptured(err, vm, info) {
            this.error = true;
            this.erroredComponent = {name: vm.$options.name, height: '' + 'px'};
            this.info = info;
            this.errorMessage = err.message;

            return false;
        },
        render: function (createElement) {
            if (this.error) {
                return createElement('div', {
                        class: ' flex alert alert-danger bg-danger component-error-container', directives: [
                            {
                                show: this.error,
                            }
                        ]
                    },
                    [
                        createElement('p', ``),
                        createElement('p', `-> in "${this.info}" function :`),
                        createElement('details', this.errorMessage),
                    ]);
            }

            return this.$slots.default[0];
        },
    };
</script>
<style>

    .component-error-container{
        min-height: 30px;
        max-height: inherit;
        max-width: 80%;
        min-width: 80%;
        height: auto;
        margin: 0 auto !important;
        padding: 0 !important;
        overflow-y: scroll;
    }
    .component-error-container > p{
        margin: 0;
        padding: 0;
    }
</style>
